# empty debugsourcefiles.list
%global debug_package %{nil}

%global upstreamname ROCm-CompilerSupport
%global rocm_release 5.7
%global rocm_patch 1
%global rocm_version %{rocm_release}.%{rocm_patch}

%global install_prefix %{_libdir}/rocm/llvm

%define libname    %mklibname %{name} %{rocm_version}
%define devel_name %mklibname %{name} -d

%define somajor   2
%define sominor   5

Name:           rocm-compilersupport
Version:        %{rocm_version}
Release:        %mkrel 2
Summary:        Various AMD ROCm LLVM related services
Group:          System/Libraries
Url:            https://github.com/RadeonOpenCompute/ROCm-CompilerSupport
License:        NCSA
Source0:        https://github.com/RadeonOpenCompute/%{upstreamname}/archive/refs/tags/rocm-%{version}.tar.gz#/%{upstreamname}-rocm-%{version}.tar.gz

BuildRequires:  rocm-cmake = %rocm_version
BuildRequires:  rocm-llvm-devel = %rocm_version
BuildRequires:  cmake(AMDDeviceLibs) = %rocm_version
BuildRequires:  pkgconfig(zlib)

#Only the following architectures are useful for ROCm packages:
ExclusiveArch:  x86_64 aarch64

%description
This package currently contains one library, the Code Object Manager (Comgr)


%package -n %{libname}
Summary:        AMD ROCm LLVM Code Object Manager
Group:          System/Libraries
Provides:       comgr(rocm) = %{rocm_version}
Requires:       rocm-device-libs = %{rocm_version}

%description -n %{libname}
The AMD Code Object Manager (Comgr) is a shared library which provides
operations for creating and inspecting code objects.


%package -n %{devel_name}
Summary:        AMD ROCm LLVM Code Object Manager
Group:          Development/Other
Provides:       comgr-devel(rocm) = %{rocm_version}
Requires:       %{libname} = %{rocm_version}

%description -n %{devel_name}
The AMD Code Object Manager (Comgr) development package.

The API is documented in the header file:
"%{_includedir}/amd_comgr.h"

%prep
%autosetup -p1 -n %{upstreamname}-rocm-%{version}

##Fix issue wit HIP, where compilation flags are incorrect, see issue:
#https://github.com/RadeonOpenCompute/ROCm-CompilerSupport/issues/49
#Remove redundant includes:
sed -i '/Args.push_back(HIPIncludePath/,+1d' lib/comgr/src/comgr-compiler.cpp
sed -i '/Args.push_back(ROCMIncludePath/,+1d' lib/comgr/src/comgr-compiler.cpp

%build
%cmake \
    -Wno-dev \
    -S "./lib/comgr" \
    -B build \
    -DBUILD_TESTING=OFF \
    -DCMAKE_PREFIX_PATH=%{install_prefix} \
    -DCMAKE_C_COMPILER=%{install_prefix}/bin/clang \
    -DLLVM_DIR=%{install_prefix}/lib/cmake/llvm \
    -DClang_DIR=%{install_prefix}/lib/cmake/clang \
    -DLLD_DIR=%{install_prefix}/lib/cmake/lld

%cmake_build

%install
%cmake_install


%files -n %{libname}
%license LICENSE.txt
%doc README.md
%{_libdir}/libamd_comgr.so.%{somajor}
%{_libdir}/libamd_comgr.so.%{somajor}.%{sominor}
#Files already included:
%exclude %{_datadir}/doc/amd_comgr/*
%exclude %{_datadir}/doc/amd_comgr-asan/*

%files -n %{devel_name}
%{_includedir}/amd_comgr/amd_comgr.h
%{_includedir}/amd_comgr.h
%{_libdir}/libamd_comgr.so
%{_libdir}/cmake/amd_comgr{,.*}


%changelog
* Sat Jun 28 2025 umeabot <umeabot> 5.7.1-2.mga10
+ Revision: 2220784
- Mageia 10 Mass Rebuild

* Tue Dec 19 2023 squidf <squidf> 5.7.1-1.mga10
+ Revision: 2019899
- Upstream version 5.7.1

* Sun Jun 18 2023 squidf <squidf> 15.1-1.mga9
+ Revision: 1962352
-Build for Mageia required by AMD OpenCL

